//  ** Revision History **
//  22-Jun-1992 (AH) Moved to PWB
//---------------------------------------------------------------------------
// ccInit.c
//---------------------------------------------------------------------------
// Custom Control DLL Initialization
//---------------------------------------------------------------------------

#define  NOCOMM
#include <windows.h>

#include <vbapi.h>
#include "esvbar.h"

//---------------------------------------------------------------------------
// External Variables & functions
//---------------------------------------------------------------------------
LONG FAR PASCAL _export AboutPopupWndProc(HWND hwnd, USHORT msg, USHORT wp, LONG lp);
LONG FAR PASCAL _export ColorPopupWndProc(HWND hwnd, USHORT msg, USHORT wp, LONG lp); 

extern MODEL modelVBar;     		// From vbar.h
extern MODELINFO modelinfoVBar;
extern MODEL modelVBar_Vb1;    		// From vb1.h
extern MODELINFO modelinfoVBar_Vb1;
extern MODEL modelVBar_Vb2;     	// From vb2.h
extern MODELINFO modelinfoVBar_Vb2;            

//---------------------------------------------------------------------------
// Global Variables
//---------------------------------------------------------------------------
HANDLE  hmodDLL;
WORD   	cVbxUsers = 0;
BOOL   	fDevTimeInited = FALSE;
HCTL    hctlDialog;
WORD    ipropDialog;
USHORT  VBVersion;

//---------------------------------------------------------------------------
// Register custom control.
//      This routine is called by VB when the custom control DLL is
//      loaded for use.
//---------------------------------------------------------------------------

BOOL FAR PASCAL _export VBINITCC(USHORT usVersion, BOOL fRuntime)
{
    BOOL        rv;                           
#ifndef RUNTIMEVERSION
    WNDCLASS    EsColorclass; 
#endif    
    // Avoid warnings on unused (but required) formal parameters
    fRuntime  = fRuntime;
    VBVersion = usVersion;

    // Count the number of hosts using this VBX.  A host can be vb.exe,
    // any .exe compiled from vb which uses this custom control, or any
    // other program which loads and uses VBX files.
    ++cVbxUsers;
    
#ifdef RUNTIMEVERSION
	if (!fRuntime) {   
	MessageBox(NULL,(LPSTR)"This custom control can't be used in the design envirement. Use Design mode version.",
					(LPSTR)"EuroSource Buttons - Load Error", MB_ICONSTOP);
	VBSetErrorMessage(ERR_NotDesign, ERR_NotDesignStr);   
	return 0;
	}
#else             
     
     // Register ABOUT popup class if this is from the development environment.
    if (!fRuntime && !fDevTimeInited) {
	WNDCLASS    Aboutclass;

	Aboutclass.style         = 0;
	Aboutclass.lpfnWndProc   = (WNDPROC)AboutPopupWndProc;
	Aboutclass.cbClsExtra    = 0;
	Aboutclass.cbWndExtra    = 0;
	Aboutclass.hInstance     = hmodDLL;
	Aboutclass.hIcon         = NULL;
	Aboutclass.hCursor       = NULL;
	Aboutclass.hbrBackground = NULL;
	Aboutclass.lpszMenuName  = NULL;
	Aboutclass.lpszClassName = "AboutClass";  
	
	if (!RegisterClass(&Aboutclass))
		return FALSE;
    }
     
    if (usVersion < 0x0200) {
	EsColorclass.style         = 0;
	EsColorclass.lpfnWndProc   = (WNDPROC)ColorPopupWndProc;
	EsColorclass.cbClsExtra    = 0;
	EsColorclass.cbWndExtra    = 0;
	EsColorclass.hInstance     = hmodDLL;
	EsColorclass.hIcon         = NULL;
	EsColorclass.hCursor       = NULL;
	EsColorclass.hbrBackground = NULL;
	EsColorclass.lpszMenuName  = NULL;
	EsColorclass.lpszClassName = "EsColorClass";  
	
	if (!RegisterClass(&EsColorclass))
		return FALSE;
		
	// We successfully initialized the stuff we need at dev time
	fDevTimeInited = TRUE;	
    }                    
#endif // designtime dialogs

    // Register controls
    // * * * VBar * * *
    if(!(rv = VBRegisterModel(hmodDLL, &modelVBar)))
	return(rv);
      
    // registration done
	return rv;
}

    
//---------------------------------------------------------------------------
// Unregister custom control.  This routine is called by VB when the custom
// control DLL is being unloaded.
//---------------------------------------------------------------------------
VOID FAR PASCAL _export VBTERMCC
(
    VOID
)
{
    --cVbxUsers;
    if (cVbxUsers == 0 && fDevTimeInited)
	{
		// Free any resources created for Dev environment
		UnregisterClass("AboutClass", hmodDLL);
		UnregisterClass("EsColorClass", hmodDLL);
	}                               
	
    return;
}
    
    
//---------------------------------------------------------------------------
// Initialize library.
//      This routine is called from the DLL entry point in LIBINIT.ASM
//      which is called when the first client loads the DLL.
//---------------------------------------------------------------------------

int FAR PASCAL LibMain(HANDLE hModule, WORD wDataSeg, WORD cbHeapSize, LPSTR  lpszCmdLine)
{
    // Avoid warnings on unused (but required) formal parameters
    wDataSeg    = wDataSeg;
    cbHeapSize  = cbHeapSize;
    lpszCmdLine = lpszCmdLine;

    hmodDLL = hModule;

    return 1;
}                      

//---------------------------------------------------------------------------
// Provide custom control model information to host environment.
//---------------------------------------------------------------------------
LPMODELINFO FAR PASCAL _export VBGetModelInfo(USHORT usVersion)
{
	if (usVersion <= VB100_VERSION)
		return &modelinfoVBar_Vb1;

    if (usVersion <= VB200_VERSION)
		return &modelinfoVBar_Vb2;
    else
		return &modelinfoVBar;
}      
//---------------------------------------------------------------------------
