//**************************************************************************
//                     Copyright (C) 1992 EuroSource AB
//
//      FUNCTION:       ESVBAR.H
//
//      PURPOSE:        Headerfile for ESVBAR custom control 
//
//      COMMENTS:        
//
//      HISTORY:        920506AH Prehistory 
//
//**************************************************************************

// take away comment here to build runtime-version
//#define RUNTIMEVERSION        1

// here we have define switches
// a switch should be defined for a custom control to
// be included in the VBX-file. This file is allways named
// Eurotool.vbx
  

#define VERSIONSTR      "EuroSource Buttons v.%2d.%2d.%2d.%3d"      

//---------------------------------------------------------------------------
// Helpful Macros
//---------------------------------------------------------------------------
#define OFFSETIN( struc, field )  ( (USHORT)&( ((struc *)0)->field ) )
 
#define OK      0L

//---------------------------------------------------------------------------
// User defined messages
//---------------------------------------------------------------------------
#define WM_USER_BASE        80  
#define BN_GROUPUP          WM_USER+WM_USER_BASE
#define CM_OPENABOUTDLG     WM_USER+WM_USER_BASE+1
#define CM_OPENCOLORDLG         WM_USER+WM_USER_BASE+2

//---------------------------------------------------------------------------
// Resource ID's
//---------------------------------------------------------------------------
// Toolbox bitmap resource IDs.
//---------------------------------------------------------------------------
// Push
#define IDBMP_VBAR          8000
#define IDBMP_VBARDOWN      8001
#define IDBMP_VBARMONO      8003
#define IDBMP_VBAREGA       8006

// Colordefinitions
#define BLACK       0x000000
#define WHITE       0xFFFFFF
#define GREY        0xC0C0C0
#define DARKGREY    0x808080
#define RED         0x0000FF
#define BLUE        0xFF0000
#define GREEN       0x00FF00

// Horizontal alignment of text
#define HALIGNLEFT              0
#define HALIGNCENTER            1
#define HALIGNRIGHT             2

// Vertical alignment of text
#define VALIGNTOP               0
#define VALIGNCENTER            1
#define VALIGNBOTTOM            2

// Font3D
#define FONT3DNORMAL        0
#define FONT3DCARVEDLIGHT   1
#define FONT3DCARVEDHEAVY   2
#define FONT3DRAISEDLIGHT   3
#define FONT3DRAISEDHEAVY   4

// 3D border styles
#define BORDERSTYLENORMAL   0
#define BORDERSTYLECARVED   1
#define BORDERSTYLERAISED   2

//---------------------------------------------------------------------------
// Standard Error Values
//---------------------------------------------------------------------------
#define ERR_None          0
#define ERR_InvPropVal    380     // Error$(380) = "Invalid property value"
#define ERR_OutMem        7       // Error$(7) =   "Out of Memory"
#define ERR_Timer         260     // Error$(260) = "No Timer Available"
#define ERR_BadIndex      381     // Error$(381) = "Invalid property array index
//----------------------------------------------------------------------------
// User defined Error Messages
//----------------------------------------------------------------------------
#define ERR_BadPixFmt       32000   // format for pictureformat.
#define ERR_BadPixFmtStr    "Picture format not supported."
#define ERR_NotDesign           32001   // Not a design mode DLL
#define ERR_NotDesignStr    "This Custom Control file can only be used in runtime mode"
//---------------------------------------------------------------------------
// Constants used by About dialog box
//---------------------------------------------------------------------------
#define ABOUTICON               100

#define IDD_OK                  1
#define IDD_CANCEL              2

#define IDD_ABOUTICON           0x210
#define IDD_TITLELINE           0x211
#define IDD_VERSION             0x212
#define IDD_BYLINE              0x213
#define IDD_WINDOWSMODE         0x214
#define IDD_FREEMEM             0x215
#define IDD_RESOURCES           0x216 

#define IDS_MODE_STANDARD       0x300
#define IDS_MODE_ENHANCED       0x301
#define IDS_MODE_WLO            0x302
#define IDS_MODE_UNDEF          0x303
#define IDS_LIC1                0x304
#define IDS_LIC2                0x305
#define IDS_VERSION             0x306

// Public Prototypes
VOID FAR PASCAL _export DrawFont3D(HDC hDC, LPSTR CaptionStr, LPRECT rect, SHORT align, SHORT type3D, SHORT mode, DWORD txtcolor);
BOOL FAR PASCAL _export EnumButtons(HWND hWnd, DWORD lp); 
VOID FAR SetAboutText(HCTL hctl, UINT prop);
LONG FAR PASCAL _export AboutPopupWndProc(HWND hwnd, USHORT msg, USHORT wp, LONG lp);
BOOL FAR PASCAL _export AboutDlgProc(HWND hDlg, USHORT msg, USHORT wp, LONG lp);
HWND FAR HwndInitAboutPopup(VOID);
LONG FAR PASCAL _export ColorPopupWndProc(HWND hwnd, USHORT msg, USHORT wp, LONG lp);
BOOL FAR PASCAL _export ColorDlgProc(HWND hDlg, USHORT msg, USHORT wp, LONG lp);
HWND FAR HwndInitColorPopup(VOID);
VOID FAR PASCAL _export DrawButton(HDC hdc, LPRECT rect, LONG lightcolor, LONG darkcolor);
HWND FAR PASCAL _export GethWnd(HCTL hctl);
