//  ** Revision History **
//  14-Mar-1993 (AH) Release 1.0.0.000
//  24-Jun-1992-1995 (AH) Added Change Event when Value is changed from Code
//  22-Jun-1992-1995 (AH) Flyttat till PWB
		   
//****************************************************************************                   
//                    Copyright (C) 1992-1995 EuroSource AB
//
// FILE:         vbar.c
//   
// PURPOSE:      A VBar class for Visual Basic that generates change-events
//               even if the user has not released the left mouse button.
//   
// COMMENTS:     
//   
// HISTORY:      920611 Prehistory
//   
//****************************************************************************                    

#define  NOCOMM
#include <windows.h>
#include <vbapi.h>
#include <string.h>
#include "esvbar.h"

#include "version.h"
#define  CTL_DATA
#include "vbar.h"
#include "vb1.h"	// Support for Visual Basic 1.0
#include "vb2.h"	// Support for Visual Basic 2.0
#include "helpid.h"

//---------------------------------------------------------------------------
// Global Variables
//---------------------------------------------------------------------------
extern HANDLE hmodDLL;
extern WORD ipropDialog;
extern HCTL hctlDialog;


//---------------------------------------------------------------------------
// VBar Control Procedure
//---------------------------------------------------------------------------
LONG FAR PASCAL _export VBarCtlProc(HCTL hctl, HWND hWnd, USHORT msg, USHORT wp, LONG lp)
{
    PVBAR pvbar = NULL;

    switch (msg)
    {   
	case WM_CREATE:
	    pvbar = (PVBAR)VBDerefControl(hctl);
	    pvbar->LargeChange = 1;
	    pvbar->SmallChange = 1;
	    pvbar->Min=0;
	    pvbar->Max = 32767;
		pvbar->Value = 0;

#ifndef RUNTIMEVERSION	     
	    // set the property text for the About dialog
	    SetAboutText(hctl, IPROP_VBAR_ABOUT);         
#endif	    
        
	    // Set default Scrollrange
		SetScrollRange(hWnd, SB_CTL, pvbar->Min, pvbar->Max, FALSE);
	    break;

#ifndef RUNTIMEVERSION
	case WM_RBUTTONDBLCLK: 
	    if (VBGetMode() == MODE_DESIGN) 
        {
			WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, esvscroll);
			return OK;
	    }
	    else
			break;
#endif

	case VBM_GETDEFSIZE:
            return MAKELONG(VBAR_DEFAULTWIDTH,VBAR_DEFAULTHEIGHT);    
        	
	case VBM_SETPROPERTY:
	switch(wp) {
	    case IPROP_VBAR_MIN:
	    case IPROP_VBAR_MAX:
		pvbar = (PVBAR)VBDerefControl(hctl);
		SetScrollRange(hWnd, SB_CTL, pvbar->Min, pvbar->Max, TRUE);
		return ERR_None;
	    case IPROP_VBAR_VALUE:
		pvbar = (PVBAR)VBDerefControl(hctl);
		SetScrollPos(hWnd, SB_CTL, pvbar->Value, TRUE);
		VBFireEvent(hctl, IEVENT_VBAR_CHANGE, NULL);
		return ERR_None;
	    case IPROP_VBAR_LARGECHANGE:
		return ERR_None;
	    case IPROP_VBAR_SMALLCHANGE:
		return ERR_None;
	}
	break;

	case VBM_GETPROPERTY:
	switch(wp) {
	    LPWORD  pprop = (LPWORD)lp;
	    case IPROP_VBAR_VALUE:
		pvbar = (PVBAR)VBDerefControl(hctl);
		pvbar->Value = (SHORT)GetScrollPos(hWnd, SB_CTL);
		return ERR_None;
	}
	break;
	
	case VBN_VSCROLL:
	    switch (wp) {
	      case SB_LINEUP:
		    pvbar = (PVBAR)VBDerefControl(hctl);
		    pvbar->Value -= pvbar->SmallChange;
		    if (pvbar->Value < pvbar->Min)
			pvbar->Value = pvbar->Min;
		    break;
				  
		case SB_LINEDOWN:
		    pvbar = (PVBAR)VBDerefControl(hctl);
		    pvbar->Value += pvbar->SmallChange;
		    if (pvbar->Value > pvbar->Max)
			pvbar->Value = pvbar->Max;
		    break;
		    
		case SB_PAGEUP:
		    pvbar = (PVBAR)VBDerefControl(hctl);
		    pvbar->Value -= pvbar->LargeChange;
		    if (pvbar->Value < pvbar->Min)
			pvbar->Value = pvbar->Min;                  
		    break;
		    
		case SB_PAGEDOWN:
		    pvbar = (PVBAR)VBDerefControl(hctl);
		    pvbar->Value += pvbar->LargeChange;
		    if (pvbar->Value > pvbar->Max)
			pvbar->Value = pvbar->Max; 
		    break;
		    
		case SB_THUMBPOSITION:
		    pvbar = (PVBAR)VBDerefControl(hctl);
		    pvbar->Value = (SHORT)lp;
		    break;
		    
		case SB_THUMBTRACK:
		    pvbar = (PVBAR)VBDerefControl(hctl);
		    pvbar->Value = (SHORT)lp;
		    break;
		   
		case SB_BOTTOM:
		    pvbar = (PVBAR)VBDerefControl(hctl);
		    pvbar->Value = pvbar->Max;
		    break;
		    
		case SB_TOP:
		    pvbar = (PVBAR)VBDerefControl(hctl);
		    pvbar->Value = pvbar->Min;
		    break;
		    
	    }
	    pvbar = (PVBAR)VBDerefControl(hctl);
	    SetScrollPos(hWnd, SB_CTL, pvbar->Value, TRUE);
	    VBFireEvent(hctl, IEVENT_VBAR_CHANGE, NULL); 
	    return ERR_None; 

#ifndef RUNTIMEVERSION    
    	    
	case VBM_INITPROPPOPUP:
	switch (wp) {
	    case IPROP_VBAR_ABOUT:
		hctlDialog  = hctl;
		ipropDialog = wp;
		return (LONG)HwndInitAboutPopup();
	}
	break;

	case VBM_HELP:
	    switch (LOBYTE(wp))
		{
			case VBHELP_PROP:
		    	// High byte identifies which property.
		    	// Keyword is: "<property>"
		    	switch (HIBYTE(wp))
				{
					case IPROP_VBAR_ABOUT:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_about);
			    		return OK;

					case IPROP_VBAR_LARGECHANGE:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_largechange);
			    		return 0L;                                                        
                
                	case IPROP_VBAR_MAX:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_max);
			    		return 0L; 
            	
                	case IPROP_VBAR_MIN:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_min);
			    		return 0L;                                            
            
            		case IPROP_VBAR_SMALLCHANGE:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_smallchange);
			    		return 0L;                                            
            
            		case IPROP_VBAR_VALUE:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_value);
			    		return 0L;                                            
                
                    case IPROP_VBAR_HWND: 
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_hwnd);
			    		return 0L;                                             
				}
				break;

		case VBHELP_CTL:
		    // High byte is unused.
		    // Keyword is: "<classname>"
		    WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, esvscroll);;
		    return 0L;
	}
	break;                                           
#endif
        	
    }
    return VBDefControlProc(hctl, hWnd, msg, wp, lp);
}
