//****************************************************************************
//                    Copyright (C) 1992-1995 EuroSource AB
//
// FILE:         vbar.h
//   
// PURPOSE:      vertical Scrollbar for Visual Basic
//   
// COMMENTS:     A Vertical Scrollarea that generate change events even
//               if the user has not released the left mouse button.
//   
// HISTORY:      920611AH
//   
//****************************************************************************                    

//---------------------------------------------------------------------------
// Control and Window Procedures
//---------------------------------------------------------------------------
LONG FAR PASCAL _export VBarCtlProc(HCTL, HWND, USHORT, USHORT, LONG);
LONG FAR PASCAL _export AboutPopupWndProc(HWND hwnd, USHORT msg, USHORT wp, LONG lp);

// Default Width & Height
#define	VBAR_DEFAULTHEIGHT	90
#define VBAR_DEFAULTWIDTH	18

//---------------------------------------------------------------------------
// VBAR control data and structs
//---------------------------------------------------------------------------
typedef struct tagVBAR
{
    HSZ     hszabout;
    SHORT   LargeChange;
    SHORT   SmallChange;
    SHORT   Min;
    SHORT   Max;
    SHORT   Value;
} VBAR;

typedef VBAR FAR * PVBAR;



#ifndef RC_INVOKED
//---------------------------------------------------------------------------
// Property list
//---------------------------------------------------------------------------
// Define the consecutive indicies for the properties
//---------------------------------------------------------------------------
#define IPROP_VBAR_CTLNAME              0
#define IPROP_VBAR_INDEX                1
#define IPROP_VBAR_LEFT                 2
#define IPROP_VBAR_TOP                  3
#define IPROP_VBAR_WIDTH                4
#define IPROP_VBAR_HEIGHT               5
#define IPROP_VBAR_VISIBLE              6
#define IPROP_VBAR_PARENT               7
#define IPROP_VBAR_DRAGMODE             8
#define IPROP_VBAR_DRAGICON             9
#define IPROP_VBAR_TAG                 10
#define IPROP_VBAR_TABINDEX	       		11
#define IPROP_VBAR_TABSTOP	       		12
#define IPROP_VBAR_ENABLED	       		13
#define IPROP_VBAR_MOUSEPOINTER        	14
#define IPROP_VBAR_ABOUT	       		15
#define IPROP_VBAR_LARGECHANGE	       	16
#define IPROP_VBAR_SMALLCHANGE	       	17
#define IPROP_VBAR_MIN		       		18
#define IPROP_VBAR_MAX		       		19
#define IPROP_VBAR_VALUE               	20
#define IPROP_VBAR_HWND					21

#ifdef CTL_DATA

PROPINFO Property_VBar_About =
{
    "About...",
    DT_HSZ | PF_fGetData | PF_fSetData | PF_fEditable,
    OFFSETIN(VBAR, hszabout)
};

PROPINFO Property_VBar_LargeChange =
{
    "LargeChange",
    DT_SHORT | PF_fGetData | PF_fSetData | PF_fSetMsg | PF_fSaveData,
    OFFSETIN(VBAR, LargeChange)
};

PROPINFO Property_VBar_SmallChange =
{
    "SmallChange",
    DT_SHORT | PF_fGetData | PF_fSetData | PF_fSetMsg | PF_fSaveData,
    OFFSETIN(VBAR, SmallChange)
};

PROPINFO Property_VBar_Min =
{
    "Min",
    DT_SHORT | PF_fGetData | PF_fSetData | PF_fSetMsg | PF_fSaveData,
    OFFSETIN(VBAR, Min)
};

PROPINFO Property_VBar_Max =
{
    "Max",
    DT_SHORT | PF_fGetData | PF_fSetData | PF_fSetMsg | PF_fSaveData,
    OFFSETIN(VBAR, Max)
};

PROPINFO Property_VBar_Value =
{
    "Value",
    DT_SHORT | PF_fGetData | PF_fSetData | PF_fSaveData | PF_fSetMsg,
    OFFSETIN(VBAR, Value)
};

PROPINFO Property_VBar_hWnd =
{
    "hWnd",
    DT_SHORT | PF_fGetMsg | PF_fNoShow | PF_fNoRuntimeW,
    0, 0
};                 

PPROPINFO VBar_Properties[] =
{
    PPROPINFO_STD_CTLNAME,
    PPROPINFO_STD_INDEX,
    PPROPINFO_STD_LEFT,
    PPROPINFO_STD_TOP,
    PPROPINFO_STD_WIDTH,
    PPROPINFO_STD_HEIGHT,
    PPROPINFO_STD_VISIBLE,
    PPROPINFO_STD_PARENT,
    PPROPINFO_STD_DRAGMODE,
    PPROPINFO_STD_DRAGICON,
    PPROPINFO_STD_TAG,
    PPROPINFO_STD_TABINDEX,
    PPROPINFO_STD_TABSTOP,
    PPROPINFO_STD_ENABLED,
    PPROPINFO_STD_MOUSEPOINTER,
    &Property_VBar_About,
    &Property_VBar_LargeChange,
    &Property_VBar_SmallChange,
    &Property_VBar_Min,
    &Property_VBar_Max,
    &Property_VBar_Value,
    &Property_VBar_hWnd,
    NULL
};
#endif  // CTL_DATA

EVENTINFO Event_Change_VBar =
{
    "Change",
    0,
    0,
    NULL,
    NULL
};

//---------------------------------------------------------------------------
// Event list
//---------------------------------------------------------------------------
// Define the consecutive indicies for the events
//---------------------------------------------------------------------------
#define IEVENT_VBAR_CHANGE              0
#define IEVENT_VBAR_DRAGDROP            1
#define IEVENT_VBAR_DRAGOVER            2
#define IEVENT_VBAR_GOTFOCUS            3
#define IEVENT_VBAR_KEYDOWN             4
#define IEVENT_VBAR_KEYPRESS            5
#define IEVENT_VBAR_KEYUP               6
#define IEVENT_VBAR_LOSTFOCUS           7                         

#ifdef CTL_DATA

PEVENTINFO VBar_Events[] =
{
    &Event_Change_VBar,
    PEVENTINFO_STD_DRAGDROP,
    PEVENTINFO_STD_DRAGOVER,
    PEVENTINFO_STD_GOTFOCUS,
    PEVENTINFO_STD_KEYDOWN,
    PEVENTINFO_STD_KEYPRESS,
    PEVENTINFO_STD_KEYUP,
    PEVENTINFO_STD_LOSTFOCUS,
    NULL
};
#endif  // CTL_DATA


//---------------------------------------------------------------------------
// Model struct
//---------------------------------------------------------------------------
// Define the control model (using the event and property structures).
//---------------------------------------------------------------------------
#ifdef CTL_DATA
MODEL modelVBar =
{
    VB_VERSION,                         // VB version being used
    MODEL_fFocusOk |					// MODEL flags
    MODEL_fArrows | MODEL_fDesInteract,
    (PCTLPROC)VBarCtlProc,              // Control procedure
    CS_VREDRAW | CS_HREDRAW,            // Class style
    SBS_VERT,                           // Default Windows style
    sizeof(VBAR),                       // Size of VBAR structure
    IDBMP_VBAR,                         // Palette bitmap ID
    "EsVScroll",            			// Default control name
    "EsVScroll",            			// Visual Basic class name
    "Scrollbar",                        // Parent class name
    VBar_Properties,                    // Property information table
    VBar_Events,                        // Event information table
	IPROP_VBAR_VALUE, 					// default property in code window : Value
	IEVENT_VBAR_CHANGE,					// default event in code window
	IPROP_VBAR_VALUE					// standard property
};
#endif  // CTL_DATA

LPMODEL modellistVBar[] =
    {
    &modelVBar,
    NULL
    };

MODELINFO modelinfoVBar =
    {
    VB_VERSION, 			// VB version being used
    modellistVBar			// MODEL list
    };

#endif  // RC_INVOKED

//---------------------------------------------------------------------------
